Quotare ferri di armatura del c.a.

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
Nota di gestione: questa discussione origina da un altro thread, questo, attinente la determinazione del senso orario o antiorario di una polilinea. L'argomento è stato all'origine dello sviluppo poi del lisp oggetto di questo thread.


Il senso orario/orario ha senso solamente sulle polilinee CHIUSE. Che senso potresti dare ad una polilinea APERTA? Per queste basta il comando INVERTI. Al limite posso togliere dalla selezione tutte le polilinee aperte...
Innanzi tutto grazie per la risposta (oltretutto rapidissima).
Ti spiego meglio il problema, così magari mi dai qualche dritta.
Ho sviluppato una serie di programmi lisp per disegnare il Cemento armato.
In particolare i ferri, li disegno come Poliliee, sempre aperte.
Il disegno dei ferri è libero, pertanto ho delle poliline orarie e altre antiorarie.
Quando quoto le poliline succede questo:

Staffa2.jpg

Come vedi la quotature della prima staffa non è accettabile perchè le lunghezze dei segmanti si sovrappongono.
Per ovviare all'inconveniente, ho scritto 2 programmi lisp, uno per quotare le polinee in senso orario e uno per quotarle in senso antiorario.
Il problema è che, non conoscendo il senso della polinea, devo andare a tentativi, cioè:
- provare a quotare col porgramma QuotaPolineaOraria. Se questo non è accettabile devo:
- cancellare le quote fatte e ripetere l'operazione col programma QuotaPolinieaAntioraria.
Ovviamente se io conosco prima come è stata disegnata la plilinea, allora da programma faccio partire la quotatura giusta.
In pratica riunisco i due programmi e non ci sarebbe possibilità di errore perchè la gestione è affidata al programma.
Ci tengo a perfezionare quel programma perchè, ovviamente col mio mestiere (Ingegnere Strutturista) è molto usato.
Ciao e grazie per l'eventuale risposta.
 
Ultima modifica di un moderatore:

confutatis

Guest
Uhm...come ti dicevo, più di orario/antiorario bisogna parlare di inverti/non inverti. In ogni caso il programma che ho scritto direi che ti serve a poco, secondo me non è l'applicazione giusta per la tipologia di lavoro che devi svolgere. Piuttosto, se posso dare un suggerimento e dal momento che conosci il lisp, potresti creare un programma unico tipo QuotaPolinea. All'interno di questo programma ci saranno i due sottoprogrammi: QuotaPolineaOraria e QuotaPolineaAntioraria.

Ti faccio un banale schema:

Partenza QuotaPolinea
Partenza QuotaPolineaOraria come subroutine e disegno delle quote. Alla fine prompt di richiesta: Va bene? (S/N)
Se rispondi S, il programma esce, se rispondi N, cancellazione quote disegnate, partenza di QuotaPolineaAntiOraria, disegno delle quote e questa volta senza prompt di conferma.

Che ne dici? E' la prima cosa che mi è venuta in mente...
 

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
Sì potrebbe andare.
Potrei fare il test alla fine bene (/N). Oltretutto con di default.
Secondo te se la risposta dovesse essere N, che comando potrei utlizzare per ritornare alla posizione voluta.
1) potrei utilizzare il comando undo (esiste in lisp?) n vole indietro pari al numero di segmenti della polilinea (è un dato che ho).
2) in alternativa è possibile fissare un punto del programma (prima della quotatura della polilinea) e poi da programma ritornare indietro a quel punto?.
Farò degli esperimenti.
Mi fa piacere parlare con un espserto di Lisp. Mi sono sempre arrangiato da solo a fare i programmi (da molti anni). Se avessi avuto la possibilità di scambiare opinioni con qualcuno sarebbe stato molto più facile. In ogni modo, mi sono fatto, negli anni, degli ottimi applicativi per la gestione dei cementi armati.

ciao, e se hai quache suggerimento, ben venga.
 

confutatis

Guest
Non occorre sapere di quanti segmenti devi tornare indietro, ti basta usare la combinazione _UNDO _BEGIN e _UNDO _END oppure, se usi anche VLisp, le funzioni vla-StartUndoMark e vla-EndUndoMark.

Forse lo sai già, ma prima della richiesta se va bene inserisci (initget "S N"), In questo modo accetterà solo le risposte S o N:

(initget "S N")
(setq risp(strcase (getkword "\nVa Bene? (S/N)")))

In questo modo, anche se inserisco la minuscola, mi viene convertita in maiuscola.
 

GP.

Utente Senior
Professione: Nientologo
Software: uozapp
Regione: Vercelli
...quache suggerimento, ben venga.
Come giustamente detto da Confutatis non ha senso parlare di orario/antiorario in poly aperte, visto che però già disponi delle routine per la quotatura valuta questa soluzione che può risolvere il tuo caso partendo dal concetto interno/esterno.

Pseudocodice:
- calcolo del punto di selezione sulla poly
- calcolo del vertice della poly immediatamente prima del punto di selezione e dei due successivi
- calcolo di un punto immediatamente alla destra del punto di selezione
- verifica se quest'ultimo risulta all'interno o all'esterno del triangolo composto dai tre vertici precedenti
- se risulta all'interno il verso è orario, altrimenti antiorario.

La routine, adattata e inserita all'inizio, permette quindi di sapere quale delle tue lanciare.
Visto che per il calcolo necessitano i due vertici successivi al punto di selezione, prestare attenzione a NON selezionare la poly nel suo tratto finale.


430.gif


Codice:
(defun c:test ( / PL psel p1 n_par v1 v2 v3 pt L_v)
    (setq PL (entsel "Selezionare la staffa"))
    (setq psel (cadr PL))
    (setq PL (car PL))
    (setq p1 (vlax-curve-getClosestPointTo (vlax-ename->vla-object PL) psel T))
    (setq n_par (fix (vlax-curve-getparamatpoint PL p1)))
    (setq v1 (vlax-curve-getpointatparam PL n_par))
    (setq v2 (vlax-curve-getpointatparam PL (1+ n_par)))
    (setq v3 (vlax-curve-getpointatparam PL (+ 2 n_par)))
    (setq pt (polar p1 (- (angle v1 v2) (/ pi 2)) 0.001))
    (setq L_v (list v1 v2 v3 v1))
    (if (punto_interno L_v pt) (alert "ORARIO") (alert "ANTIORARIO"))
)
    
;-------------------------------------------------------
(defun punto_interno (*LP* *p* / P_lontano attr p# Pa Pb )
    (setq P_lontano (list (car (setq em (getvar 'extmax))) (1+ (cadr em))))
    (setq attr 0)
    (repeat (1- (length *LP*))
        (setq Pa (car *LP*))
        (setq Pb (cadr *LP*))
        (setq P# (inters Pa Pb *p* P_lontano))
        (if (/= P# nil) (setq attr (1+ attr)))
        (setq *LP* (cdr *LP*))     
    )
    (if (> (rem attr 2) 0) T nil)
)
;-------------------------------------------------------
(vl-load-com)
 

confutatis

Guest
Dal momento che bisogna prestare attenzione a NON selezionare la polilinea nel tratto finale, siamo al punto di partenza di non conoscere il verso.
 

Joseph

Utente Standard
Professione: studio e sperimento
Software: autocad 2012
Regione: lombardia
Come vedi la quotature della prima staffa non è accettabile perchè le lunghezze dei segmanti si sovrappongono.

Quindi significa che nella seconda staffa accetti come valide delle quote capovolte? Questo dipende forse dal fatto che riorienti ogni volta l'asse X dell'UCS sul lato della staffa che stai quotando?
 

GP.

Utente Senior
Professione: Nientologo
Software: uozapp
Regione: Vercelli
Dal momento che bisogna prestare attenzione a NON selezionare la polilinea nel tratto finale, siamo al punto di partenza di non conoscere il verso.
No... intendevo il primo o l'ultimo segmento, per il motivo che ho esposto.
Cliccando sull'immagine viene visualizzata una verifica del test.
 

confutatis

Guest
Usando una polilinea qualsiasi, a seconda del segmento cliccato, mi dà orario e/o antiorario...:frown:
 

GP.

Utente Senior
Professione: Nientologo
Software: uozapp
Regione: Vercelli
Il codice è pensato per staffe simili a quelle postate da betoniera, ovvero rettangolari, triangolari o comunque di forma convessa.
Se vai un po' a destra e un po' a sinistra non funge. :smile:
 

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
Ciao confutatis, ciao GP.
Grazie dei suggerimenti.
Ho sistemato il programma come suggerito da confutatis e funziona già.
Ho unito i 2 programmi in uno, per cui è il programma finale ha una duplicazione quasi identica di istruzioni. Non è proprio il massimo come programmazione però funziona. Più avanti magari cercherò di razionalizzarlo.
Per tornare indietro dopo la prima quotatura di tentativo ho usato le istruzioni "Annulla Segno" e "Annulla Indietro" di Autocad.
Funzionano bene.
Ho ancora qualche piccola cosa da mettere a posto, ma il progrmma è già operativo.
Grazie dell'aiuto, alla prossima.
 

confutatis

Guest
Piccola variazione al lisp di GP.
Adesso posso anche cliccare sugli estremi della polilinea, viene sempre preso per la selezione il punto centrale. Il comando non funziona sulle polilinee che hanno solo 2 vertici.


Codice:
(defun c:teston ( / PL psel p1 n_par v1 v2 v3 pt L_v)
    (setq PL (car (entsel "Selezionare la staffa")))
    (setq p1 (vlax-curve-getPointAtDist (vlax-ename->vla-object PL) (/ (vla-get-Length (vlax-ename->vla-object PL)) 2))) 
    (setq n_par (fix (vlax-curve-getparamatpoint PL p1)))
    (setq v1 (vlax-curve-getpointatparam PL n_par))
    (setq v2 (vlax-curve-getpointatparam PL (1+ n_par)))
    (setq v3 (vlax-curve-getpointatparam PL (+ 2 n_par)))
    (setq pt (polar p1 (- (angle v1 v2) (/ pi 2)) 0.001))
    (setq L_v (list v1 v2 v3 v1))
    (if (punto_interno L_v pt) (alert "ORARIO") (alert "ANTIORARIO"))
)
    
;-------------------------------------------------------
(defun punto_interno (*LP* *p* / P_lontano attr p# Pa Pb )
    (setq P_lontano (list (car (setq em (getvar 'extmax))) (1+ (cadr em))))
    (setq attr 0)
    (repeat (1- (length *LP*))
        (setq Pa (car *LP*))
        (setq Pb (cadr *LP*))
        (setq P# (inters Pa Pb *p* P_lontano))
        (if (/= P# nil) (setq attr (1+ attr)))
        (setq *LP* (cdr *LP*))     
    )
    (if (> (rem attr 2) 0) T nil)
)
;-------------------------------------------------------
(vl-load-com)
 

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
E' interessante questo spezzone di lisp.
Provo a fare degli esperimenti.
Se funziona, è preferibile rispetto alla soluzione di prima perchè il controllo della poliliea destrorsa o sinistrorsa verrebbe fatto da programma.
Inoltre i due programmi separati più semplici e gestibili rispetto al programma unico, più lungo e complicato.
Il problema della polilina formata da un solo segmento non c'è perchè la quotatura è unica e non si può sovrapporre a nessun altro testo.
Vi farò sapere se la soluzione escogiata da GP funziona.

Ciao, ci risentiamo
 

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
Ciao GP
Avrei voluto complimentarti con te per il codice così compatto e pieno di comandi che non conosco e di cui, per la verità non ben capito l'algoritmo di soluzione
Purtroppo le prove affettuate danno esito negativo nel senso che il codice a volte funziona, a volte no, a volte da risultati errati.
Quindi, semmai c'è una competizione tra te e cofutatis, stavolta gliela diamo vinta a confutatis (ci rifaremo la prossima volta).
Poi, siccome nel Forum bisogna pur condividere qualcosa, trasmetto il mio lavoro nel file Qpoly2.lsp
Se lo guardate non inorridite perchè per brevità ho sommato due programmi, quindi il listato è lungo e ripetitivo.
Ma chissenefrega perchè l'importante è che funzioni.
Per gli utenti informo che io non utlizzo la funzione defun c:, ma preferisco caricarlo da programma associato ad un tasto.
Quindi utlizzare (load "Qpoly2").
Dopo la quotatura della polilinea il progrmma si ferma e chiede conferma. premento return completa la scritta posizionabile a piacere con l'inclinazione a piacere
(vedi esempio sotto).
Se si preme N (no) le quotature spariscono e la polilinea vine riquotata con testo all'esterno.
L'altezza del testo è di 2 mm assoluti, cioè moltiplicato per il valore della varibile dimscale
Quello stto è un esempio di sezione 1/20 con la staffa in alto con la quotatura sospesa ina ttesa di ok. A destra la quotatura rettificata
Ciao, alla prossima

Staffa5.jpg
 

Allegati

Ultima modifica di un moderatore:

confutatis

Guest
Programma interessante e stimolante.
Pensandoci bene e ragionando, ho visto che la conformazione delle staffe deve seguire una certa logica e cioè, seguendo progressivamente i vertici, gli angoli della polilinea devono sempre essere minori di 180 gradi. Con questo presupposto ho seguito una strada diversa da quella percorsa da GP e cioè il controllo degli angoli della staffa. Se tutti gli angoli sono maggiori di 180 gradi, uso la funzione di inversione dei vertici della polilinea, creata tempo fa. Le ultime versioni di AutoCAD prevedono il comando apposito INVERTI, ma il programma funziona su tutte le versioni. In questo modo non occorre più la richiesta se i testi vanno bene o meno.
Dal momento che il programma ha il defun e per quanto attiene al pulsante potresti cambiare la stringa così:
^C^C(if (null C:QPOLY3)(load "QPOLY3"));QPOLY3
 

Allegati

Betoniera

Utente Junior
Professione: Ingegnere
Software: Autodesk Robot
Regione: Lombardia
Ciao Confutatis
Ma chi sei: il mago Lisp?
Hai deciso di stracciarci?
Ti ringrazio davvero per il tempo che mi stai dedicando.
Però ho provato il programma ma mi dà il seguente errore

; errore: no function definition: LISTACOORD

Eppure la funzione è dentro. Sarà la solita parentesi non al posto giusto

Ti confesso che 1/3 delle istruzioni che usi non le ho mai viste.
Ma dove lo hai studiato il lisp così, alla Cambridge University?
Me lo sistemi il programma che sono curioso di provarlo?.
Ciao e grazie
 

confutatis

Guest
Alla riga 70 manca la parentesi che chiude il princ...bah, o mi dimentico il vl-load-com o le parentesi...
 

GP.

Utente Senior
Professione: Nientologo
Software: uozapp
Regione: Vercelli
Programma interessante e stimolante...
Quoto, anche perchè ne prevedo il possibile utilizzo.

Io rimango comunque sul concetto di interno/esterno per il riposizionamento dei testi, nel lisp allegato questi sono vere "QUOTE", ciò ha i suoi vantaggi:
- orientamento dei testi sempre consono allo standard
- aggiornamento automatico in caso di stiramento

Per quest'ultimo aspetto ho previsto anche l'aggiornamento automatico della lunghezza della poly inserendo il valore in un CAMPODATI, ma con lo spostamento nel codice di qualche puntoevirgola si può utilizzare un testo semplice.

In teoria dovrebbe funzionare con qualunque tipo di stile di quota in quanto i valori vengono adattati, unico aspetto: lo stile deve prevedere il posizionamento dei testi sopra o sotto la linea di quota.

Direi che è una versione "quasi" beta, in quanto (per ora) è previsto il funzionamento per disegno in metri e quote in cm.

Vedremo gli sviluppi...


431.gif
 

Allegati

confutatis

Guest
In effetti la quota senza linee di quota e linee di estensione diventa in tutto e per tutto uguale al programma originario di Betoniera, strano che non abbia previsto l'utilizzo delle quote invece del testo, forse è una sua esigenza, boh...